JmxBuilderModelMBean (groovy 2.4.14 API)
Date: 2018-02-24

Package: groovy.jmx.builder

## [Java] Class JmxBuilderModelMBean

- groovy.jmx.builder.JmxBuilderModelMBean

- All Implemented Interfaces and Traits:
    NotificationListener

      public class JmxBuilderModelMBean
      extends RequiredModelMBean

  The JmxBuilderModelMBean is the MBean class that proxies exported POGO/POJO inside the MBeanServer. When JmxBuilder exports an object instance, an instance of this class is created and exported inside the MBeanServer.

  Authors:
    Vladimir Vivien

- - ### Constructor Summary

    Constructors
    Constructor and description
    `JmxBuilderModelMBean (Object objectRef)`
    `JmxBuilderModelMBean ()`
    `JmxBuilderModelMBean (ModelMBeanInfo mbi)`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `void` | `addEventListeners(MBeanServer server, Map<String, Map<String, Object>> descriptor)` Sets up event listeners for this MBean as described in the descriptor.
    `` | `void` | `addOperationCallListeners(Map<String, Map<String, Map<String, Object>>> descriptor)` Registers listeners for operation calls (i.e. method, getter, and setter calls) when invoked on this bean from the MBeanServer.
    `` | `void` | `handleNotification(Notification note, Object handback)`
    `` | `Object` | `invoke(String opName, Object[] opArgs, String[] signature)`
    `` | `void` | `setManagedResource(Object obj)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class RequiredModelMBean` | `invoke, load, store, getAttributes, addAttributeChangeNotificationListener, postDeregister, postRegister, preDeregister, removeAttributeChangeNotificationListener, sendAttributeChangeNotification, sendAttributeChangeNotification, setManagedResource, setModelMBeanInfo, getAttribute, setAttribute, getNotificationInfo, sendNotification, sendNotification, addNotificationListener, removeNotificationListener, removeNotificationListener, setAttributes, preRegister, getMBeanInfo, wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Constructor Detail

    - #### public JmxBuilderModelMBean(Object objectRef)

    - #### public JmxBuilderModelMBean()

    - #### public JmxBuilderModelMBean(ModelMBeanInfo mbi)

  - ### Method Detail

    - #### public void addEventListeners(MBeanServer server, Map<String, Map<String, Object>> descriptor)

      Sets up event listeners for this MBean as described in the descriptor. The descriptor contains a map with layout {item -> Map[event:"...", from:ObjectName, callback:&Closure],...,}

      Parameters:
        `server` - the MBeanServer is to be registered.
        `descriptor` - a map containing info about the event

    - #### public void addOperationCallListeners(Map<String, Map<String, Map<String, Object>>> descriptor)

      Registers listeners for operation calls (i.e. method, getter, and setter calls) when invoked on this bean from the MBeanServer. Descriptor should contain a map with layout item -> [Map[methodListener:[target:"", tpe:"", callback:&Closure], ... ,]]

      Parameters:
        `descriptor` - MetaMap descriptor containing description of operation call listeners

    - #### public void handleNotification(Notification note, Object handback)

    - #### @Override public Object invoke(String opName, Object[] opArgs, String[] signature)

    - #### public void setManagedResource(Object obj)